//+---------------------------------------------------------------------------+
#property copyright "" 
//+------------------------------------------------------------------+
#include <WinUser32.mqh>
#include <stdlib.mqh>
//+------------------------------------------------------------------+
#import "user32.dll"
	int RegisterWindowMessageA(string lpString); 
#import
//+------------------------------------------------------------------+
extern double RenkoBoxSize = 3;
extern double RenkoBoxOffset = 0;
extern int RenkoTimeFrame = 2;      // What time frame to use for the offline renko chart
extern bool ShowWicks = true;
extern bool EmulateOnLineChart = true;
extern bool StrangeSymbolName = false,recalculate=false;
	static double BoxPoints,BoxOffset, UpWick, DnWick;
	static double PrevLow, PrevHigh, PrevOpen, PrevClose,PrevClose1, CurVolume, CurLow, CurHigh, CurOpen, CurClose,lasthigh,lastlow;
	static datetime PrevTime;
   static double  volume,lastvolume;	
//+------------------------------------------------------------------+
int HstHandle = -1, LastFPos = 0, MT4InternalMsg = 0;
string SymbolName;
//+------------------------------------------------------------------+
void UpdateChartWindow() {
	static int hwnd = 0;
 
	if(hwnd == 0) {
		hwnd = WindowHandle(SymbolName, RenkoTimeFrame);
		if(hwnd != 0) Print("Chart window detected");
	}

	if(EmulateOnLineChart && MT4InternalMsg == 0) 
		MT4InternalMsg = RegisterWindowMessageA("MetaTrader4_Internal_Message");

	if(hwnd != 0) if(PostMessageA(hwnd, WM_COMMAND, 0x822c, 0) == 0) hwnd = 0;
	if(hwnd != 0 && MT4InternalMsg != 0) PostMessageA(hwnd, MT4InternalMsg, 2, 1);

	return;
}
//+------------------------------------------------------------------+
int init()
{
	if(HstHandle < 0) 
   {
      if(!IsConnected()) 
      {
         Print("Waiting for connection...");
			return(0);
		}							
		if(!IsDllsAllowed()) 
		{
			Print("Error: Dll calls must be allowed!");
			return(-1);
		}		
		if(MathAbs(RenkoBoxOffset) >= RenkoBoxSize) 
		{
			Print("Error: |RenkoBoxOffset| should be less then RenkoBoxSize!");
			return(-1);
		}
		switch(RenkoTimeFrame) 
		{
         case 1: case 5: case 15: case 30: case 60: case 240:
         case 1440: case 10080: case 43200: case 0:
			Print("Error: Invald time frame used for offline renko chart (RenkoTimeFrame)!");
			return(-1);
		}
		//
		double BoxSize = RenkoBoxSize;
		BoxOffset = RenkoBoxOffset;
		if(Digits == 5 || (Digits == 3 && StringFind(Symbol(), "JPY") != -1)) 
		{
			BoxSize = BoxSize*10;
			BoxOffset = BoxOffset*10;
		}
		if(Digits == 6 || (Digits == 4 && StringFind(Symbol(), "JPY") != -1)) 
		{
			BoxSize = BoxSize*100;		
			BoxOffset = BoxOffset*100;
		}
		if(StrangeSymbolName) SymbolName = StringSubstr(Symbol(), 0, 6);
		else SymbolName = Symbol();
		BoxPoints = NormalizeDouble(BoxSize*Point, Digits);
		HstHandle = FileOpenHistory(SymbolName + RenkoTimeFrame + ".hst", FILE_BIN|FILE_READ);
		if(HstHandle<0 || recalculate)
		{
         if(!HstHandle<0)FileClose(HstHandle);
		   if(NewFile()==-1){Alert("Could not create file"); return(-1);}
         int size=FileSize(HstHandle);
         Alert("file size="+size);
         UpdateChartWindow();						
		   return(0);
      }
      else
      {
         FileClose(HstHandle);
         HstHandle = FileOpenHistory(SymbolName + RenkoTimeFrame + ".hst", FILE_BIN|FILE_WRITE|FILE_READ);
         size=FileSize(HstHandle);
         Alert("file size="+size);
         if(size<236)
         {
            FileClose(HstHandle);
            Alert("Corrupted file, creating new one");
            if(NewFile()==-1){Alert("Could not create file"); return(-1);}
            size=FileSize(HstHandle);
            Alert("file size="+size);
            return;
         }
         if(size==148)
         {
            FileClose(HstHandle);
//            if(NewFile()==-1){Alert("Could not create file"); return(-1);}
         }
         if((size-148)%44!=0){Alert("Corrupted file - size mismatch");bool c=NewFile();size=FileSize(HstHandle);Alert("file size="+size);return(0);}
         bool s=FileSeek(HstHandle,-88,SEEK_END);
         PrevTime=FileReadInteger(HstHandle, LONG_VALUE);
         PrevOpen=FileReadDouble(HstHandle, DOUBLE_VALUE);
         PrevLow=FileReadDouble(HstHandle, DOUBLE_VALUE);
         PrevHigh=FileReadDouble(HstHandle, DOUBLE_VALUE);
         PrevClose=FileReadDouble(HstHandle, DOUBLE_VALUE);
         CurVolume=FileReadDouble(HstHandle, DOUBLE_VALUE);
         LastFPos = FileTell(HstHandle);   // Remeber Last pos in file				  							
         PrevTime=FileReadInteger(HstHandle, LONG_VALUE);
         PrevOpen=FileReadDouble(HstHandle, DOUBLE_VALUE);
         PrevLow=FileReadDouble(HstHandle, DOUBLE_VALUE);
         PrevHigh=FileReadDouble(HstHandle, DOUBLE_VALUE);
         PrevClose=FileReadDouble(HstHandle, DOUBLE_VALUE);
         CurVolume=FileReadDouble(HstHandle, DOUBLE_VALUE);
         lasthigh=MathFloor((PrevClose+BoxPoints)/BoxPoints)*BoxPoints;
         lastlow=MathFloor(PrevClose/BoxPoints)*BoxPoints;
      }
   }	 		
}  
int start() 
{

	// Begin live data feed
   			

   if(lastvolume>Volume[0])
   {
      lastvolume=Volume[0];
      volume=Volume[0];
   }
   else
   {
      volume=Volume[0]-lastvolume;
      lastvolume=Volume[0];
   }
   if(volume==0)volume=1;
	FileSeek(HstHandle, LastFPos, SEEK_SET);
//   Print("last pos=",LastFPos);
 	//-------------------------------------------------------------------------	   				
//    up box
      if(Bid>lasthigh+BoxPoints || CompareDoubles(Bid,lasthigh+BoxPoints))
      {
         while(Bid>lasthigh+BoxPoints || CompareDoubles(Bid,lasthigh+BoxPoints))
         {
            lasthigh+=BoxPoints;
         }
         FileWriteInteger(HstHandle, PrevTime, LONG_VALUE);
         FileWriteDouble(HstHandle, PrevOpen, DOUBLE_VALUE);

         FileWriteDouble(HstHandle, PrevLow, DOUBLE_VALUE);
		  			
         FileWriteDouble(HstHandle, PrevHigh, DOUBLE_VALUE);
         FileWriteDouble(HstHandle, PrevClose, DOUBLE_VALUE);
         FileWriteDouble(HstHandle, CurVolume, DOUBLE_VALUE);
         FileFlush(HstHandle);
         LastFPos = FileTell(HstHandle);   // Remeber Last pos in file				  							
         lastlow=lasthigh-BoxPoints;
         PrevOpen=Bid;
         PrevClose=Bid;
         PrevHigh=Bid;
         PrevLow=Bid;
         CurVolume=volume;
         if(PrevTime>=TimeCurrent())
         {
            PrevTime++;
         }
         else
         {
            PrevTime=TimeCurrent();
         }
         FileWriteInteger(HstHandle, PrevTime, LONG_VALUE);
         FileWriteDouble(HstHandle, PrevOpen, DOUBLE_VALUE);

         FileWriteDouble(HstHandle, PrevLow, DOUBLE_VALUE);
		  			
         FileWriteDouble(HstHandle, PrevHigh, DOUBLE_VALUE);
         FileWriteDouble(HstHandle, PrevClose, DOUBLE_VALUE);
         FileWriteDouble(HstHandle, CurVolume, DOUBLE_VALUE);
         FileFlush(HstHandle);
         UpdateChartWindow();						
      }
//    down`box
      else if(Bid<lastlow-BoxPoints || CompareDoubles(Bid,lastlow-BoxPoints))
      {
         while(Bid<lastlow-BoxPoints || CompareDoubles(Bid,lastlow-BoxPoints))
         {
            lastlow-=BoxPoints;
         }
         FileWriteInteger(HstHandle, PrevTime, LONG_VALUE);
         FileWriteDouble(HstHandle, PrevOpen, DOUBLE_VALUE);
         FileWriteDouble(HstHandle, PrevLow, DOUBLE_VALUE);
         FileWriteDouble(HstHandle, PrevHigh, DOUBLE_VALUE);
         FileWriteDouble(HstHandle, PrevClose, DOUBLE_VALUE);
         FileWriteDouble(HstHandle, CurVolume, DOUBLE_VALUE);
         FileFlush(HstHandle);
         LastFPos = FileTell(HstHandle);   // Remeber Last pos in file				  							
         lasthigh=lastlow+BoxPoints;
         PrevOpen=Bid;
         PrevClose=Bid;
         PrevHigh=Bid;
         PrevLow=Bid;
         CurVolume=volume;
         if(PrevTime>=TimeCurrent())
         {
            PrevTime++;
         }
         else
         {
            PrevTime=TimeCurrent();
         }
         FileWriteInteger(HstHandle, PrevTime, LONG_VALUE);
         FileWriteDouble(HstHandle, PrevOpen, DOUBLE_VALUE);

         FileWriteDouble(HstHandle, PrevLow, DOUBLE_VALUE);
		  			
         FileWriteDouble(HstHandle, PrevHigh, DOUBLE_VALUE);
         FileWriteDouble(HstHandle, PrevClose, DOUBLE_VALUE);
         FileWriteDouble(HstHandle, CurVolume, DOUBLE_VALUE);
         FileFlush(HstHandle);
         UpdateChartWindow();						
      }
//    no box
      else
      {
         PrevClose=Bid;
         if(PrevHigh<Bid)PrevHigh=Bid;
         if(PrevLow>Bid)PrevLow=Bid;
         if(Bid<lasthigh && Bid>lastlow)PrevOpen=Bid;
         CurVolume+=volume;
         FileWriteInteger(HstHandle, PrevTime, LONG_VALUE);
         FileWriteDouble(HstHandle, PrevOpen, DOUBLE_VALUE);

         FileWriteDouble(HstHandle, PrevLow, DOUBLE_VALUE);
		  			
         FileWriteDouble(HstHandle, PrevHigh, DOUBLE_VALUE);
         FileWriteDouble(HstHandle, PrevClose, DOUBLE_VALUE);
         FileWriteDouble(HstHandle, CurVolume, DOUBLE_VALUE);
         FileFlush(HstHandle);
         UpdateChartWindow();						
      }
     	return(0);
}
//+------------------------------------------------------------------+
int deinit() {
	if(HstHandle >= 0) {
		FileClose(HstHandle);
		HstHandle = -1;
	}
   	Comment("");
	return(0);
}
//+------------------------------------------------------------------+
int   NewFile()
      {
		    // create / open hst file		
         HstHandle = FileOpenHistory(SymbolName + RenkoTimeFrame + ".hst", FILE_BIN|FILE_WRITE);
         if(HstHandle < 0) 
         {
			   Print("Error: can\'t create / open history file: " + ErrorDescription(GetLastError()) + ": " + SymbolName + RenkoTimeFrame + ".hst");
			   return(-1);
         }
		//
   	
		    // write hst file header
         int HstUnused[13];
         FileWriteInteger(HstHandle, 400, LONG_VALUE); 			// Version
         FileWriteString(HstHandle, "", 64);					// Copyright
         FileWriteString(HstHandle, SymbolName, 12);			// Symbol
         FileWriteInteger(HstHandle, RenkoTimeFrame, LONG_VALUE);	// Period
         FileWriteInteger(HstHandle, Digits, LONG_VALUE);		// Digits
         FileWriteInteger(HstHandle, 0, LONG_VALUE);			// Time Sign
         FileWriteInteger(HstHandle, 0, LONG_VALUE);			// Last Sync
         FileWriteArray(HstHandle, HstUnused, 0, 13);			// Unused
   		PrevLow = NormalizeDouble(BoxOffset*Point + MathFloor(Close[Bars-1]/BoxPoints)*BoxPoints, Digits);
   		DnWick = PrevLow;
   		PrevHigh = PrevLow + BoxPoints;
   		UpWick = PrevHigh;
   		PrevOpen = PrevLow;
   		PrevClose = PrevHigh;
   		CurVolume = 1;
   		PrevTime = Time[Bars-1]-1;
   	
 		// process historical data
         int i = Bars-2;
		//Print(Symbol() + " " + High[i] + " " + Low[i] + " " + Open[i] + " " + Close[i]);
		//---------------------------------------------------------------------------
         while(i >= 0) 
         {
            CurVolume = CurVolume + Volume[i];
            UpWick = MathMax(UpWick, High[i]);
			   DnWick = MathMin(DnWick, Low[i]);
			   // update low before high or the revers depending on is closest to prev. bar
			   bool UpTrend = High[i]+Low[i] > High[i+1]+Low[i+1];
			   while(UpTrend && (Low[i] < PrevClose-BoxPoints || CompareDoubles(Low[i], PrevClose-BoxPoints))) 
			   {
  				   PrevHigh = PrevHigh - BoxPoints;
  				   PrevLow = PrevLow - BoxPoints;
  				   PrevOpen = PrevHigh;
  				   PrevClose = PrevLow;
               FileWriteInteger(HstHandle, PrevTime, LONG_VALUE);
				   FileWriteDouble(HstHandle, PrevOpen, DOUBLE_VALUE);
				   FileWriteDouble(HstHandle, PrevLow, DOUBLE_VALUE);
				   if(ShowWicks && UpWick > PrevHigh) FileWriteDouble(HstHandle, UpWick, DOUBLE_VALUE);
               else FileWriteDouble(HstHandle, PrevHigh, DOUBLE_VALUE);
				   FileWriteDouble(HstHandle, PrevClose, DOUBLE_VALUE);
				   FileWriteDouble(HstHandle, CurVolume, DOUBLE_VALUE);
				   UpWick = 0;
				   DnWick = EMPTY_VALUE;
				   CurVolume = 0;
				   CurHigh = PrevLow;
				   CurLow = PrevLow;  
				   if(PrevTime < Time[i]) PrevTime = Time[i];
				   else PrevTime++;
            }
			   while(High[i] > PrevHigh+BoxPoints || CompareDoubles(High[i], PrevHigh+BoxPoints)) 
			   {
  				   PrevHigh = PrevHigh + BoxPoints;
  				   PrevLow = PrevLow + BoxPoints;
  				   PrevOpen = PrevLow;
  				   PrevClose = PrevHigh;
				   FileWriteInteger(HstHandle, PrevTime, LONG_VALUE);
				   FileWriteDouble(HstHandle, PrevOpen, DOUBLE_VALUE);
               if(ShowWicks && DnWick < PrevLow) FileWriteDouble(HstHandle, DnWick, DOUBLE_VALUE);
				   else FileWriteDouble(HstHandle, PrevLow, DOUBLE_VALUE);
				   FileWriteDouble(HstHandle, PrevHigh, DOUBLE_VALUE);
				   FileWriteDouble(HstHandle, PrevClose, DOUBLE_VALUE);
				   FileWriteDouble(HstHandle, CurVolume, DOUBLE_VALUE);
				   UpWick = 0;
				   DnWick = EMPTY_VALUE;
				   CurVolume = 0;
				   CurHigh = PrevHigh;
				   CurLow = PrevHigh;  
				   if(PrevTime < Time[i]) PrevTime = Time[i];
				   else PrevTime++;
            }
			   while(!UpTrend && (Low[i] < PrevLow-BoxPoints || CompareDoubles(Low[i], PrevLow-BoxPoints))) 
			   {
  				   PrevHigh = PrevHigh - BoxPoints;
  				   PrevLow = PrevLow - BoxPoints;
  				   PrevOpen = PrevHigh;
  				   PrevClose = PrevLow;
				   FileWriteInteger(HstHandle, PrevTime, LONG_VALUE);
				   FileWriteDouble(HstHandle, PrevOpen, DOUBLE_VALUE);
				   FileWriteDouble(HstHandle, PrevLow, DOUBLE_VALUE);
				   if(ShowWicks && UpWick > PrevHigh) FileWriteDouble(HstHandle, UpWick, DOUBLE_VALUE);
				   else FileWriteDouble(HstHandle, PrevHigh, DOUBLE_VALUE);
				   FileWriteDouble(HstHandle, PrevClose, DOUBLE_VALUE);
				   FileWriteDouble(HstHandle, CurVolume, DOUBLE_VALUE);
   				UpWick = 0;
				   DnWick = EMPTY_VALUE;
				   CurVolume = 0;
				   CurHigh = PrevLow;
				   CurLow = PrevLow;  
				   if(PrevTime < Time[i]) PrevTime = Time[i];
				   else PrevTime++;
			   }		
			   i--;
         } 
         LastFPos = FileTell(HstHandle);   // Remember Last pos in file
         if(PrevOpen>PrevClose)
         {
            lasthigh=PrevOpen;
            lastlow=PrevClose;
         }
         else
         {
            lasthigh=PrevClose;
            lastlow=PrevOpen;
         }
         PrevClose=Close[0];
         if(PrevHigh<Close[0])PrevHigh=Close[0];
         if(PrevLow>Close[0])PrevLow=Close[0];
         if(Close[0]<lasthigh && Close[0]>lastlow)
         {
            PrevOpen=Close[0];
         }
         else
         {
            if(Close[0]>=lasthigh)
            {
               PrevOpen=lasthigh;
            }
            else if(Close[0]<=lastlow) 
            {
               PrevOpen=lastlow;
            }
         }
         FileWriteInteger(HstHandle, PrevTime, LONG_VALUE);
         FileWriteDouble(HstHandle, PrevOpen, DOUBLE_VALUE);
         FileWriteDouble(HstHandle, PrevLow, DOUBLE_VALUE);
         FileWriteDouble(HstHandle, PrevHigh, DOUBLE_VALUE);
         FileWriteDouble(HstHandle, PrevClose, DOUBLE_VALUE);
         FileWriteDouble(HstHandle, CurVolume, DOUBLE_VALUE);
         FileFlush(HstHandle);
         Comment("RenkoLiveChart(" + RenkoBoxSize + "): Open Offline ", SymbolName, ",M", RenkoTimeFrame, " to view chart");
         UpdateChartWindow();            
         return(0);
 		// End historical data / Init		
      }   